#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#include "common.h"
#include "aiplayer.h"
#include "search.h"
#include "sighant.h"

static int side,depth,winrow;
static player_t *player;
struct sigaction sigact;



extern int continuesearch;


player_t *ai_get_player(int m, int n, int d){
	player = malloc(sizeof(player_t));
	side = m;
	depth = d;
	winrow = n;
	player->next_move = ai_next_move;

	return player;
}

pos_t* ai_next_move(gamestate_t *state){
	pos_t *p = malloc(sizeof(pos_t));
	pos_t tp;
	int currdepth;

	continuesearch = 1;

	sigact.sa_handler = sighant;
	sigemptyset(&sigact.sa_mask);
	sigact.sa_flags = 0;
	sigaction(SIGINT, &sigact, NULL);

	//Iterative deepening here.
	for (currdepth = 1; currdepth <= depth && continuesearch; currdepth++) {
		alphabeta(state, currdepth, -INT_MAX, INT_MAX, winrow, &tp);
		if(continuesearch)
			*p = tp;		
	}
	sigact.sa_handler = SIG_DFL;
	sigemptyset(&sigact.sa_mask);
	sigact.sa_flags = 0;
	sigaction(SIGINT, &sigact, NULL);
	return p;
}

void ai_free_quit(gamestate_t *state){
	free(player);
}


