import java.io.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;


public class Main {

	private Network n2;

	public Main(File f) {
		BufferedReader r = null;
		try {
			r = new BufferedReader(new FileReader(f));
		} catch (FileNotFoundException e) {
			System.err.println("Filen fanns inte!");
			System.exit(1);
		}
		String line;
		List<String> linelist = new ArrayList<String>();
		try {
			while ((line = r.readLine()) != null) {
				line = line.trim();
				if (!line.equals("") && !line.startsWith("#")) {
					linelist.add(line);
				}
			}
		} catch (IOException e) {
			System.err.println("Fel vid inlsning");
			System.exit(1);
		}
		
		String network = linelist.get(0);
		if (network.equals("NETWORK-2")) {
			n2 = Network.network1Factory();
			for (String s : linelist) {
//				System.out.println(s);
				if (s.toUpperCase().startsWith("P")) {
//					System.out.println("startswith p");
					n2.insertProbability(s);
//					System.out.println(n2);
				} else if (s.toUpperCase().startsWith("Q")) {
//					System.out.println(n2);
					Identifier s1t = new Identifier("Symptom", true);
					Identifier s1f = new Identifier("Symptom", false);
					Identifier d1t = new Identifier("Disease-1", true);
					Identifier d1f = new Identifier("Disease-1", false);
					Identifier d2t = new Identifier("Disease-2", true);
					Identifier d2f = new Identifier("Disease-2", false);
					
					HashSet<Identifier> hs = new HashSet<Identifier>();
//					hs.add(s1t);
					
					//Q(Disease-1|Symptom)
					
					double[] dist = n2.enumerationAsk(d1t, hs);
					System.out.println("Distribution: "+dist[0]);
					System.out.println("Distribution: "+dist[1]);
					
					
				}
			}
		}



//		for (String s : linelist) {
//			System.out.println(s);
//		}
	}

	
	
	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("Fel args");
			System.exit(1);
		}
		File f = new File(args[0]);
		new Main(f);
	}

}
