import java.util.*;


@SuppressWarnings("serial")
public class Network extends HashMap<String, Node> {

	public void printNodes() {
		for (String s : keySet()) {
			Node n = get(s);
			System.out.println(s+":");
			System.out.println(n.table.toString());
		}
	}

	public static Network network1Factory() {
		Network n = new Network();
		Node d1 = new Node("Disease-1");
		Node d2 = new Node("Disease-2");
		Node s1 = new Node("Symptom");
		s1.parents.add(new Identifier(d1.id, false));
		s1.parents.add(new Identifier(d2.id, false));

		n.put("Disease-1", d1);
		n.put("Disease-2", d2);
		n.put("Symptom", s1);

		return n;
	}
	
	
	private double[] normalize(double[] Q) {
		double[] normalized = new double[2];
		normalized[0] = Q[0]/(Q[0]+Q[1]);
		normalized[1] = Q[1]/(Q[0]+Q[1]);
		return normalized;
	}

	private Double P(Identifier y, HashSet<Identifier> parents) {
//		System.out.println("i P()");
//		System.out.println("P y: "+y);
		System.out.println("P parents: "+parents);
		if (parents.isEmpty()) {
			Node n = get(y.getId());
//			System.out.println("P n: "+n);
			HashSet<Identifier> hs = new HashSet<Identifier>();
			hs.add(y);
			Double d = n.table.get(hs);
//			System.out.println("P d: "+d);
			return d;
		} else {
			System.out.println("P y: "+y);
//			System.out.println("P parents: "+parents);
			Node n = get(y.getId());
			Double d = n.table.get(parents);
			System.out.println("P d: "+d);
			return d;
		}
	}
	
	
	@SuppressWarnings("unchecked")
	private double enumerateAll(ArrayList<Node> vars, HashSet<Identifier> e) {
		if (vars.isEmpty()) {
			return 1.0;
		}
		Node Y = vars.remove(0);
		boolean exists = false;
		Identifier y = null;
		for (Identifier i : e) {
			if (i.getId().equals(Y.id)) {
				y = i;
				exists = true;
				break;
			}
		}
//		System.out.println("enumAll exists: "+exists);
//		System.out.println("enumAll y: "+y);
		if (exists) {
			return P(y, parents(Y, e)) * enumerateAll((ArrayList<Node>)vars.clone(), e);
			
//			return P(y, Y.parents) * enumerateAll((ArrayList<Node>)vars.clone(), e); 
		} else {
			//TODO: DET R HR VI GR FEL!
			HashSet<Identifier> e1 = (HashSet<Identifier>)e.clone();
			HashSet<Identifier> e2 = (HashSet<Identifier>)e.clone();
			System.out.println("P e: "+e);
			
			y = new Identifier(Y.id, true);
			e1.add(y);
			Double d1 = P(y, parents(Y, e1)) * enumerateAll((ArrayList<Node>)vars.clone(), e1);
			System.out.println("enumAll d1: "+d1);
			
			Identifier y2 = y.opposite();
			e2.add(y2);
			Double d2 = P(y2, parents(Y, e2)) * enumerateAll((ArrayList<Node>)vars.clone(), e2);
			System.out.println("enumAll d2: "+d2);
			
			return d1 + d2;
		}
	}

	private HashSet<Identifier> parents(Node n, HashSet<Identifier> e) {
		HashSet<Identifier> hs = new HashSet<Identifier>();
		for (Identifier i : e) {
			for (Identifier j : n.parents) {
				if (j.getId().equals(i.getId())) {
					hs.add(i);
				}
			}
		}
		System.out.println("PARENTS TILL "+n.id+": "+hs);
		return hs;
	}
	
	
	@SuppressWarnings("unchecked")
	public double[] enumerationAsk(Identifier X, HashSet<Identifier> e) {
		Network bn = this;
		double[] Q = new double[2];
		HashSet<Identifier> e1 = (HashSet<Identifier>) e.clone();
		HashSet<Identifier> e2 = (HashSet<Identifier>) e.clone();
		
		e1.add(X);
		e2.add(X.opposite());
		
//		System.out.println("enumAsk e1: "+e1);
//		System.out.println("enumAsk e2: "+e2);
		
		ArrayList<Node> vars = new ArrayList<Node>();
		for (Node n : bn.values()) {
			vars.add(n);
		}
//		System.out.println("enumAsk vars: "+vars);
		Q[0] = enumerateAll((ArrayList<Node>)vars.clone(), e1);
		Q[1] = enumerateAll((ArrayList<Node>)vars.clone(), e2);
		
		return normalize(Q);
	}
	
	public void insertProbability(String s) {
		s = s.replaceAll(" ", "");
		String[] sides = s.split("=");
		double d = Double.parseDouble(sides[1]);
		String s2 = sides[0].substring(sides[0].indexOf('(')+1, sides[0].indexOf(')'));
		String sides2[] = s2.split("\\|");
		String id;
		if (sides2[0].startsWith("!")) {
			id = sides2[0].substring(1);
		} else {
			id = sides2[0];
		}
		Node n = this.get(id);
		if (sides2.length == 1) {
			Identifier i1, i2;
			if (sides2[0].startsWith("!")) {
				i2 = new Identifier(id, true);
				i1 = new Identifier(sides2[0].substring(1), false);	
			} else {
				i1 = new Identifier(id, true);
				i2 = new Identifier(sides2[0], false);
			}
			
			HashSet<Identifier> hs1 = new HashSet<Identifier>();
			HashSet<Identifier> hs2 = new HashSet<Identifier>();
			hs1.add(i1);
			hs2.add(i2);
			n.table.put(hs1, d);
			n.table.put(hs2, 1.0-d);
		} else {
			String[] parts3 = sides2[1].split(",");
			HashSet<Identifier> hs = new HashSet<Identifier>();
			for (String s3 : parts3) {
				Identifier i;
				if (s3.startsWith("!")) {
					i = new Identifier(s3.substring(1), false);
				} else {
					i = new Identifier(s3, true);
				}
				hs.add(i);
			}
			n.table.put(hs, d);
		}
	}

}
