
public class Identifier {

	private String id;
	private boolean value;
	
	public Identifier(String i, boolean v) {
		id = i;
		value = v;
	}
	
	public String toString() {
		if (value) {
			return id;
		} else {
			return "^"+id;
		}
	}
	
	public boolean equals(Object o) {
		Identifier b = (Identifier)o;
		return this.id.equals(b.id) && this.value == b.value;
	}
	
	public Identifier opposite() {
		return new Identifier(id, !value);
	}
	
	public void toggleValue() {
		value = !value;
	}

	public String getId() {
		return id;
	}
	
	public int hashCode() {
		return (id+value).hashCode();
	}
	
	public boolean getValue() {
		return value;
	}
}
