#!/bin/bash

# Usage: ./check <jarfile> <training-set> <correct-set> <test-set>

# If the weight matrix doesn't exist, create it.
if [ ! -f "matrix.dat" ]; then
    java -jar $1 train $2 $3
fi

# Run the program
tmp="temp.dat"
java -jar $1 guess $4 > $tmp

# Extract the meaningful stuff
tot=`head -n 3 $4 | tail -1`
err=`diff $tmp $3 | grep "<" | wc -l`

# Cleanup
rm -rf $tmp

# Output
echo "Errors: $err/$tot"