package pic;

/**
 * Faces have four basic types.
 * @author eric
 */
public enum FaceType {
	/**
	 * A happy face. 
	 */
	HAPPY(1),
	/**
	 * A sad face. 
	 */
	SAD(2),
	
	/**
	 * A mischievous face
	 */
	MISCHIEF(3),
	
	/**
	 * A mad face.
	 */
	MAD(4);

	private int state;

	/**
	 * @param s Gives the face type from an integer representation. 
	 * @return The face type.
	 */
	public static FaceType fromInt(int s) {
		switch (s) {
		case 1: return HAPPY;
		case 2: return SAD;
		case 3: return MISCHIEF;
		case 4: return MAD;
		default: throw new IllegalArgumentException("Invalid facetype");
		}
	}

	private FaceType(int s) {
		state = s;
	}

	/**
	 * @return The face type as its integer representation.
	 */
	public int toInt() {
		return state;
	}

	public String toString() {
		switch (this) {
		case HAPPY: return "Happy";
		case SAD: return "Sad";
		case MISCHIEF: return "Mischievous";
		case MAD: return "Mad";
		default: return "Unknown facetype x(";
		}
	}
}
